part of masamune;

FocusNode useAutoFocusNode([bool autoFocus = true]) {
  final focusNode = useFocusNode();
  useEffect(
    () {
      if (autoFocus) {
        focusNode.requestFocus();
      }
      return () {};
    },
    [focusNode],
  );
  return focusNode;
}

extension WidgetRefFocusNodeExtensions on WidgetRef {
  FocusNode useFocusNode(String key, [bool autoFocus = true]) {
    return containerBuilder<FocusNode, FocusNode>(
      key: "focusNode:$key",
      containerBuilder: (container) {
        final focusNode = FocusNode();
        if (autoFocus) {
          focusNode.requestFocus();
        }
        return focusNode;
      },
      resultBuilder: (container) {
        return container;
      },
    );
  }
}
