part of masamune;

extension WidgetRefValueNotifierExtensions on WidgetRef {
  ValueNotifier<T> useValueNotifier<T>(String key, T defaultValue) {
    return containerBuilder<_ValueNotifierContainer<T>, ValueNotifier<T>>(
      key: "valueNotifier:$key",
      containerBuilder: (container) {
        container?.dispose();
        return _ValueNotifierContainer<T>(
          value: ValueNotifier<T>(defaultValue),
          ref: this,
          defaultValue: defaultValue,
        );
      },
      resultBuilder: (container) {
        return container.value;
      },
      test: (container) => container.defaultValue != defaultValue,
    );
  }
}

@immutable
class _ValueNotifierContainer<T> extends VariableContainer {
  _ValueNotifierContainer({
    required this.value,
    required this.ref,
    required this.defaultValue,
  }) {
    value.addListener(_handledOnUpdate);
  }

  final ValueNotifier<T> value;
  final WidgetRef ref;
  final T defaultValue;

  @override
  void dispose() {
    value.removeListener(_handledOnUpdate);
    super.dispose();
  }

  void _handledOnUpdate() {
    ref.rebuild();
  }
}
